Index: dl145/targets/amd/serengeti_cheetah/Config.lb
===================================================================
--- dl145.orig/targets/amd/serengeti_cheetah/Config.lb	2009-04-28 08:50:35.000000000 -0600
+++ dl145/targets/amd/serengeti_cheetah/Config.lb	2009-04-28 08:50:43.000000000 -0600
@@ -2,86 +2,24 @@
 # the amd serengeti_cheetah 
 # This will make a target directory of ./serengeti_cheetah
 
-target serengeti_cheetah
+target cbfs
 mainboard amd/serengeti_cheetah
 
-# serengeti_leopard
-romimage "normal"
-#       48K for SCSI FW
-#        option ROM_SIZE = 475136
-#       48K for SCSI FW and 48K for ATI ROM
-#       option ROM_SIZE = 425984 
-#       64K for Etherboot
-#        option ROM_SIZE = 458752 
-	option USE_FAILOVER_IMAGE=0
-	option USE_FALLBACK_IMAGE=0
-#	option ROM_IMAGE_SIZE=0x13800
-#	option ROM_IMAGE_SIZE=0x18800
-	option ROM_IMAGE_SIZE=0x20000
-#	option ROM_IMAGE_SIZE=0x15800
-	option XIP_ROM_SIZE=0x40000
-	option COREBOOT_EXTRA_VERSION="$(shell cat ../../VERSION)_Normal"
-#       payload ../../../payloads/tg3--ide_disk.zelf
-#        payload ../../../payloads/filo.elf
-#        payload ../../../payloads/filo_mem.elf
-#        payload ../../../payloads/filo.zelf
-#        payload ../../../payloads/tg3--filo_hda2.zelf
-#	payload ../../../payloads/tg3.zelf
-#	payload ../../../../payloads/tg3_vga.zelf
-#	payload ../../../../payloads/tg3--filo_hda2_vga.zelf
-#	payload ../../../../payloads/tg3--filo_hda2_vga_5.4.1.zelf
-#	payload ../../../../payloads/e1000_vga.zelf
-#	payload ../../../../payloads/tg3--filo_hda2_vga_5_4.zelf
-#	payload ../../../payloads/tg3_com2.zelf
-#       payload ../../../payloads/e1000--filo.zelf
-#        payload ../../../payloads/tg3--e1000--filo.zelf
-#        payload ../../../payloads/tg3--eepro100--e1000--filo_hda2.zelf
-#	payload ../../../payloads/tg3--eepro100--e1000--filo_hda2_5.3.zelf
-#	payload ../../../payloads/tg3--eepro100--e1000--filo_hda2_com2.zelf
-	payload ../payload.elf
-end
+option FAILOVER_SIZE = 0
+option HAVE_FAILOVER_BOOT = 0
+
+option ROM_SIZE = 512*1024
+option CONFIG_CONSOLE_SERIAL8250 = 1
+option CONFIG_CONSOLE_VGA = 1
+option XIP_ROM_SIZE = 0x20000
+option ROM_IMAGE_SIZE = 0x20000
+option FALLBACK_SIZE = ROM_SIZE
+option CONFIG_CBFS = 1
 
 romimage "fallback" 
-	option USE_FAILOVER_IMAGE=0
 	option USE_FALLBACK_IMAGE=1
-#	option ROM_IMAGE_SIZE=0x13800
-#	option ROM_IMAGE_SIZE=0x19800
-	option ROM_IMAGE_SIZE=0x20000
-#	option ROM_IMAGE_SIZE=0x15800
-	option XIP_ROM_SIZE=0x40000
 	option COREBOOT_EXTRA_VERSION="$(shell cat ../../VERSION)_Fallback"
-#       payload ../../../payloads/tg3--ide_disk.zelf
-#        payload ../../../payloads/filo.elf
-#        payload ../../../payloads/filo_mem.elf
-#        payload ../../../payloads/filo.zelf
-#        payload ../../../payloads/tg3--filo_hda2.zelf
-#	payload ../../../payloads/tg3.zelf
-#	payload ../../../../payloads/tg3_vga.zelf
-#	payload ../../../../payloads/memtest
-#	payload ../../../../payloads/adlo.elf
-#	payload ../../../../payloads/e1000_vga.zelf
-#	payload ../../../../payloads/filo_hda.zelf
-#	payload ../../../../payloads/tg3--filo_hda2_vga.zelf
-#	payload ../../../../payloads/tg3--filo_hda2_vga_5_4.zelf
-#	payload ../../../../payloads/tg3--filo_hda2_vga_5.4.1.zelf
-#	payload ../../../../payloads/filo_hda2_novga.zelf
-#	payload ../../../payloads/tg3_com2.zelf
-#       payload ../../../payloads/e1000--filo.zelf
-#        payload ../../../payloads/tg3--e1000--filo.zelf
-#        payload ../../../payloads/tg3--eepro100--e1000--filo_hda2.zelf
-#	payload ../../../payloads/tg3--eepro100--e1000--filo_hda2_5.3.zelf
-#	payload ../../../payloads/tg3--eepro100--e1000--filo_hda2_com2.zelf
 	payload ../payload.elf
 end
 
-romimage "failover"
-	option USE_FAILOVER_IMAGE=1
-        option USE_FALLBACK_IMAGE=0
-        option ROM_IMAGE_SIZE=FAILOVER_SIZE
-        option XIP_ROM_SIZE=FAILOVER_SIZE
-        option COREBOOT_EXTRA_VERSION="$(shell cat ../../VERSION)_Failover"
-end
-
-
-buildrom ./coreboot.rom ROM_SIZE "normal" "fallback" "failover"
-#buildrom ./coreboot.rom ROM_SIZE "normal" "fallback" 
+buildrom ./coreboot.rom ROM_SIZE "fallback"
Index: dl145/targets/tyan/s2892/Config.lb
===================================================================
--- dl145.orig/targets/tyan/s2892/Config.lb	2009-04-28 08:50:35.000000000 -0600
+++ dl145/targets/tyan/s2892/Config.lb	2009-04-28 08:50:43.000000000 -0600
@@ -2,62 +2,23 @@
 # the Tyan s2892 
 # This will make a target directory of ./s2892
 
-target s2892
+target nocbfs
 mainboard tyan/s2892
 
-# Tyan s2892
-romimage "normal"
-#       36K for ATI ROM in 1M
-	option ROM_SIZE = 1024*1024-36*1024
-#       48K for SCSI FW or ATI ROM
-#        option ROM_SIZE = 512*1024-48*1024
-#       48K for SCSI FW and 48K for ATI ROM
-#       option ROM_SIZE = 512*1024-48*1024-48*1024
-#       64K for Etherboot
-#        option ROM_SIZE = 512*1024-64*1024
-	option USE_FALLBACK_IMAGE=0
-#	option ROM_IMAGE_SIZE=0x11800
-#	option ROM_IMAGE_SIZE=0x13800
-#	option ROM_IMAGE_SIZE=0x16380
-	option ROM_IMAGE_SIZE=0x20000
-#	option ROM_IMAGE_SIZE=0x17800
-	option XIP_ROM_SIZE=0x20000
-	option COREBOOT_EXTRA_VERSION="$(shell cat ../../VERSION)_Normal"
-#       payload ../../../payloads/tg3--ide_disk.zelf
-#        payload ../../../payloads/filo.elf
-#        payload ../../../payloads/filo_mem.elf
-#       payload ../../../payloads/filo.zelf
-#	payload ../../../payloads/tg3.zelf
-#	payload ../../../payloads/tg3_vga.zelf
-#	payload ../../../../payloads/tg3--filo_hda2_vga.zelf
-#        payload ../../../payloads/tg3--filo_hda2_com2.zelf
-#       payload ../../../payloads/e1000--filo.zelf
-#        payload ../../../payloads/tg3--e1000--filo.zelf
-#        payload ../../../payloads/tg3--eepro100--e1000--filo_hda2.zelf
-	payload ../payload.elf
-end
+option ROM_SIZE = 512*1024
+option CONFIG_CONSOLE_SERIAL8250 = 1
+option CONFIG_CONSOLE_VGA = 1
+option XIP_ROM_SIZE = 0x20000
+option ROM_IMAGE_SIZE = 0x20000
+option FALLBACK_SIZE = ROM_SIZE
+option HAVE_HIGH_TABLES = 1
+option HAVE_LOW_TABLES = 0
+option CONFIG_CBFS = 0
 
 romimage "fallback" 
 	option USE_FALLBACK_IMAGE=1
-#	option ROM_IMAGE_SIZE=0x11800
-#	option ROM_IMAGE_SIZE=0x13800
-#	option ROM_IMAGE_SIZE=0x16380
-	option ROM_IMAGE_SIZE=0x20000
-#	option ROM_IMAGE_SIZE=0x17800
-	option XIP_ROM_SIZE=0x20000
 	option COREBOOT_EXTRA_VERSION="$(shell cat ../../VERSION)_Fallback"
-#       payload ../../../payloads/tg3--ide_disk.zelf
-#        payload ../../../payloads/filo.elf
-#        payload ../../../payloads/filo_mem.elf
-#       payload ../../../payloads/filo.zelf
-#	payload ../../../payloads/tg3.zelf
-#	payload ../../../payloads/tg3_vga.zelf
-#	payload ../../../../payloads/tg3--filo_hda2_vga.zelf
-#        payload ../../../payloads/tg3--filo_hda2_com2.zelf
-#       payload ../../../payloads/e1000--filo.zelf
-#        payload ../../../payloads/tg3--e1000--filo.zelf
-#        payload ../../../payloads/tg3--eepro100--e1000--filo_hda2.zelf
 	payload ../payload.elf
 end
 
-buildrom ./coreboot.rom ROM_SIZE "normal" "fallback"
+buildrom ./coreboot.rom ROM_SIZE "fallback"
Index: dl145/src/northbridge/amd/amdk8/Config.lb
===================================================================
--- dl145.orig/src/northbridge/amd/amdk8/Config.lb	2009-04-28 08:52:21.000000000 -0600
+++ dl145/src/northbridge/amd/amdk8/Config.lb	2009-04-28 08:52:38.000000000 -0600
@@ -1,9 +1,11 @@
 uses AGP_APERTURE_SIZE
 uses HAVE_ACPI_TABLES
 uses HAVE_HIGH_TABLES
+uses HAVE_LOW_TABLES
 
 default AGP_APERTURE_SIZE=0x4000000
-default HAVE_HIGH_TABLES=1
+default HAVE_HIGH_TABLES=HAVE_ACPI_TABLES
+default HAVE_LOW_TABLES=HAVE_ACPI_TABLES
 
 config chip.h
 